Attribute VB_Name = "IsPhoner"
Option Explicit
Public Phoner_Da As Boolean

' bentigte API-Deklarationen
Private Const HKEY_CLASSES_ROOT As Long = &H80000000

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_READ = KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const REG_SZ = 1
Private Const REG_DWORD = 4
Private Const ERROR_SUCCESS = 0&

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Any) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

' Wert aus Registry auslesen
Private Function GetValue(ByVal hKey As Long, ByVal sKey As String, ByVal sField As String, vValue As Variant) As Boolean

  Dim nResult As Long
  Dim nKeyOpen As Long
  Dim dwType As Long
  Dim nValue As Long
  Dim nLen As Long
  Dim sBuffer As String

  GetValue = False

  ' Registry-Schlssel ffnen
  nResult = RegOpenKeyEx(hKey, sKey, 0, KEY_READ, nKeyOpen)
  If nResult <> ERROR_SUCCESS Then Exit Function
  
  ' Werte-Typ bestimmen
  nResult = RegQueryValueEx(nKeyOpen, sField, 0&, dwType, ByVal 0&, nLen)
  
  If nResult = ERROR_SUCCESS Then
    Select Case dwType
      Case REG_SZ
        ' String
        sBuffer = Space$(nLen + 1)
        nResult = RegQueryValueEx(nKeyOpen, sField, 0&, dwType, ByVal sBuffer, nLen)
        If nResult = ERROR_SUCCESS Then
          vValue = Left$(sBuffer, nLen - 1)
        End If
    
      Case REG_DWORD
        ' DWord
        nLen = 4
        nResult = RegQueryValueEx(nKeyOpen, sField, 0&, dwType, nValue, nLen)
        If nResult = ERROR_SUCCESS Then vValue = nValue
    End Select

    ' Schlieen
    RegCloseKey nKeyOpen
  End If
  
  GetValue = (nResult = ERROR_SUCCESS)
End Function
' Pfad anhand Klassennamen auslesen
Private Function GetClassPath(ByVal sClass As String)
  Dim sValue As String
  Dim sPath As String
  
  If GetValue(HKEY_CLASSES_ROOT, sClass & "\Clsid", "", sValue) Then
    sPath = "CLSID\" & sValue
    If GetValue(HKEY_CLASSES_ROOT, sPath, "", sValue) Then
      sPath = sPath & "\LocalServer32"
      If GetValue(HKEY_CLASSES_ROOT, sPath, "", sValue) Then
        GetClassPath = sValue
      End If
    End If
  End If
End Function
Private Function FileExist(vorlagedatei As String) As Boolean
    On Error GoTo Fehler
    Dim DateiName
    If vorlagedatei = "" Then GoTo Fehler
    DateiName = Dir(vorlagedatei, vbNormal Or vbReadOnly Or vbHidden Or vbSystem)
    If DateiName > "" Then
            'Diese Routine gilt nur, wenn KEIN WildCard dabei ist
            If InStr(vorlagedatei, "*") = 0 And InStr(vorlagedatei, "?") = 0 Then
                 'Nur wenns keine 0-Datei-lnge ist
                 If FileLen(vorlagedatei) > 0 Then
                    FileExist = True
                 Else
                    FileExist = False
                 End If
            End If
            If InStr(vorlagedatei, "*") > 0 Or InStr(vorlagedatei, "?") > 0 Then
                 'Nullenge wird nicht geprft
                 FileExist = True
            End If
    Else
            FileExist = False
    End If
Exit Function

Fehler:
FileExist = False
End Function
Private Function SYSTEM_DIR() As String
    Dim l As Long, ret As String
    ret = Space$(255)
    l = GetSystemDirectory(ret, Len(ret))
    ret = Left$(ret, l)
    SYSTEM_DIR = ret
End Function
Private Function TestDeclaration() As Boolean
    On Error GoTo Fehler
    TestDeclaration = True
    Dim TestPhoner As Object
    Set TestPhoner = New CPhoner
    Set TestPhoner = Nothing
    Exit Function
    
Fehler:
    TestDeclaration = False
End Function
Public Function PhonerExists() As Boolean
    'Alle Meldungen (msgbox) in dieser Funktion dienen nur zu Demonstrationszwecken
    'und sollten im Originalprogramm natrlich weggelassen werden, da die Auswertung
    'lediglich ber die globale Variable PhonerOK erfolgt.
    
    On Error GoTo Fehler:
    PhonerExists = False
    
    Dim sPath As String
    Dim PhonerOK As Boolean, PhonerDeclOK As Boolean, CapiOK As Boolean
    'Default erst mal alle Hilfsvariablen auf False setzen
    PhonerOK = False: PhonerDeclOK = False: CapiOK = False
    
    'ERSTE PRFUNG  ---------------------------------------------------------------------------------
    'ber Registry-Eintrag prfen, ob Phoner installiert ist
    'Zurckgegeben wird das Intstallationsverzeichnis
    sPath = GetClassPath("Phoner.CPhoner")
    'jetzt nachsehen, ob Phoner.exe tatschlich im angegebenen Verzeichnis existiert.
    If FileExist(sPath) Then
        MsgBox "Phoner ist installiert im Verzeichnis " & vbCrLf & sPath
        PhonerOK = True
    Else
        MsgBox "Phoner nicht installiert"
        'IM ORIGINALPROGRAMM: Erste Prfung nicht bestanden, also kann die Funktion schon verlassen werden
        'PhonerExists = false: exit function
    End If
    
    'ZWEITE PRFUNG  -----------------------------------------------------------------------------------
    'hier prfen wir vorsichtshalber noch einmal, ob sich ein neues Ojekt aus Phoner erstellen lt
    'damit beantworten wir (nochmal) die Frage, ob ein Phoner-Object wirklich systemweit registriert ist
    If TestDeclaration = True Then
        MsgBox "Die Applikation konnte ein neues Objekt aus dem Phoner-Objekt ableiten"
        PhonerDeclOK = True
    Else
        MsgBox "Die Applikation konnte offensichtlich kein Phoner-Objekt auf Ihrem System feststellen."
        'IM ORIGINALPROGRAMM: Zweite Prfung nicht bestanden, also kann die Funktion schon verlassen werden
        'PhonerExists = false: exit function
    End If
    
    
    'DRITTE PRFUNG  --------------------------------------------------------------------------------
    'Als letztes sollten wir noch nachsehen, ob auch ein CAPI der Version 2 installiert ist. Wir prfen
    'das einfach ber das Vorhandensein einer entsprechenden Capi-Dll.
    'Eine Funktionsprfung der Capi-DLL erfolgt nicht mehr
    If FileExist(SYSTEM_DIR & "\capi2*.dll") Then
        MsgBox "Die Prfung hat ergeben, dass auch ein CAPI der Version 2 installiert ist."
        CapiOK = True
        Else
        MsgBox "Kein Capi der Version 2 installiert"
        'IM ORIGINALPROGRAMM: Dritte Prfung nicht bestanden, also wird die Funktion endgltig verlassen
        'PhonerExists = false: exit function
    End If
    
    'DER ABSCHLUSS ----------------------------------------------------------------------------------
    'nur zu Testzwecken in die Funktion aufgenommen, um eine entsprechende Meldung anzeigen zu knnen
    'IM ORIGINALPROGRAMM: Alle Prfungen bestanden, also
    'PhonerExists = true ..... und das wars dann schon
    'auf die nachfolgenden Anweisungen kann dann natrlich verzichtet werden
    If PhonerOK = True And PhonerDeclOK = True And CapiOK = True Then
        MsgBox "Sie knnen die Funktionalitten von PHONER in Ihrer Anwendung nutzen"
        PhonerExists = True
    Else
        MsgBox "Die Funktionalitten von PHONER sind in Ihrer Anwendung NICHT nutzbar"
        PhonerExists = False
    End If
    
Exit Function
Fehler:
    PhonerExists = False
End Function
